<?php

namespace App\Http\Controllers\V1;

use App\Http\Controllers\Controller;
use App\Core\Service\PropertyRoomRateMappingSetupService;
use Illuminate\Http\Request;

use App;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Config;
use Exception;
use App\Exceptions\ApiErrorException;

class PropertyRoomRateMappingSetupController
{


    private $request;
    private $propertyRoomRateMappingSetupService;


    public function __construct(
        Request $request,
        PropertyRoomRateMappingSetupService $propertyRoomRateMappingSetupService
    )
    {
        $this->request = $request;
        $this->propertyRoomRateMappingSetupService = $propertyRoomRateMappingSetupService;

    }



    public function getPropertyRoomRateMappingSetup(Request $request)
    {

        $response = ['status' => false, 'message' => '', 'data' => null, 'statusCode' => 500];
        try {

            if (is_null($this->request->getContent())) {
                throw new ApiErrorException(lang('Parameter Error.'));
            }

            $params = $this->request->params;

            $requestParams = [
                'locale' => fillOnUndefined($params, 'locale'),
                'property_id' => fillOnUndefined($params, 'property_id'),
                'room_id' => fillOnUndefined($params, 'room_id'),
                'room_rate_mapping_id' => fillOnUndefined($params, 'room_rate_mapping_id'),
                'user_id' => $this->request->auth->id,
            ];

            $propertyRoomRateMappingSetup = $this->propertyRoomRateMappingSetupService->getPropertyRoomRateMappingSetup($requestParams);
            if($propertyRoomRateMappingSetup['status'] != 'success'){
                throw new ApiErrorException($propertyRoomRateMappingSetup['message']);
            }

            $response = ['status' => 1, 'statusCode' => 200, 'message' => null, 'data' => $propertyRoomRateMappingSetup['data']];

        } catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
            $response['statusCode'] = 400;
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
            $response['statusCode'] = 500;
        }
        return apiResponse($response['status'], $response['message'], $response['data'], $response['statusCode']);


    }

    public function addPropertyRoomRateMappingSetup(Request $request)
    {

        $response = ['status' => false, 'message' => '', 'data' => null, 'statusCode' => 500];
        try {

            if (is_null($this->request->getContent())) {
                throw new ApiErrorException(lang('Parameter Error.'));
            }

            $params = $this->request->params;

            $requestParams = [
                'locale' => fillOnUndefined($params, 'locale'),
                'property_id' => fillOnUndefined($params, 'property_id'),
                'room_id' => fillOnUndefined($params, 'room_id'),
                'room_rate_mapping_id' => fillOnUndefined($params, 'room_rate_mapping_id'),
                'setup' => fillOnUndefined($params, 'setup'),
                'user_id' => $this->request->auth->id,
            ];


            $propertyRoomRateMappingSetup = $this->propertyRoomRateMappingSetupService->addPropertyRoomRateMappingSetup($requestParams);
            if($propertyRoomRateMappingSetup['status'] != 'success'){
                throw new ApiErrorException($propertyRoomRateMappingSetup['message']);
            }

            $response = ['status' => 1, 'statusCode' => 200, 'message' => null, 'data' => $propertyRoomRateMappingSetup['data']];

        } catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
            $response['statusCode'] = 400;
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
            $response['statusCode'] = 500;
        }
        return apiResponse($response['status'], $response['message'], $response['data'], $response['statusCode']);


    }






}